#define	MGL_KEY_ESC		  1
#define	MGL_KEY_1		  2
#define	MGL_KEY_2		  3
#define	MGL_KEY_3		  4
#define	MGL_KEY_4		  5
#define	MGL_KEY_5		  6
#define	MGL_KEY_6		  7
#define	MGL_KEY_7		  8
#define	MGL_KEY_8		  9
#define	MGL_KEY_9		 10
#define	MGL_KEY_0		 11
#define	MGL_KEY_MINUS		 12
#define	MGL_KEY_EQUAL		 13
#define	MGL_KEY_ASCIICIRCUM_J	 13	/* ^ */
#define	MGL_KEY_BACKSPACE	 14


#define	MGL_KEY_TAB		 15
#define	MGL_KEY_Q		 16
#define	MGL_KEY_W		 17
#define	MGL_KEY_E		 18
#define	MGL_KEY_R		 19
#define	MGL_KEY_T		 20
#define	MGL_KEY_Y		 21
#define	MGL_KEY_U		 22
#define	MGL_KEY_I		 23
#define	MGL_KEY_O		 24
#define	MGL_KEY_P		 25
#define	MGL_KEY_LBRACKET_E	 26
#define	MGL_KEY_AT_J		 26
#define	MGL_KEY_RBRACKET_E	 27
#define	MGL_KEY_LBRACKET_J	 27
#define	MGL_KEY_ENTER		 28


#define	MGL_KEY_CAPS		 29
#define	MGL_KEY_A		 30
#define	MGL_KEY_S		 31
#define	MGL_KEY_D		 32
#define	MGL_KEY_F		 33
#define	MGL_KEY_G		 34
#define	MGL_KEY_H		 35
#define	MGL_KEY_J		 36
#define	MGL_KEY_K		 37
#define	MGL_KEY_L		 38
#define	MGL_KEY_SEMICOLON_J	 39
#define	MGL_KEY_SEMICOLON_E	 39
#define	MGL_KEY_APOSTROPHE_E	 40
#define	MGL_KEY_COLON_J		 40
#define	MGL_KEY_GRAVE_E		 41	/* ` */
#define	MGL_KEY_HANZEN_J	 41


#define	MGL_KEY_SHIFT		 42
#define	MGL_KEY_BACKSLASH_BAR_E	 43 
#define	MGL_KEY_RBRACKET_J	 43
#define	MGL_KEY_Z		 44
#define	MGL_KEY_X		 45
#define	MGL_KEY_C		 46
#define	MGL_KEY_V		 47
#define	MGL_KEY_B		 48
#define	MGL_KEY_N		 49
#define	MGL_KEY_M		 50
#define	MGL_KEY_COMMA		 51
#define	MGL_KEY_PERIOD		 52
#define	MGL_KEY_SLASH		 53
#define	MGL_KEY_RSHIFT		 54
#define	MGL_KEY_CTRL		 58
#define	MGL_KEY_ALT		 56
#define	MGL_KEY_SPACE		 57


#define	MGL_KEY_UP		 95
#define	MGL_KEY_PAGEUP		 96
#define	MGL_KEY_RIGHT		 98
#define	MGL_KEY_LEFT		 97
#define	MGL_KEY_DOWN		100
#define	MGL_KEY_PAGEDOWN	101
#define	MGL_KEY_INS		102
#define	MGL_KEY_DEL		103
#define	MGL_KEY_DEL_ALT		 83
#define	MGL_KEY_HOME		 94
#define	MGL_KEY_END		 99
#define	MGL_KEY_BACKSLASH_UNDER	115
#define	MGL_KEY_BACKSLASH_BAR_J	125

#define MGL_KEY_MENU		105

#define	MGL_KEY_F1		 59
#define	MGL_KEY_F2		 60
#define	MGL_KEY_F3		 61
#define	MGL_KEY_F4		 62
#define	MGL_KEY_F5		 63
#define	MGL_KEY_F6		 64
#define	MGL_KEY_F7		 65
#define	MGL_KEY_F8		 66
#define	MGL_KEY_F9		 67
#define	MGL_KEY_F10		 68


struct mgl_encoding {
	unsigned char kc;
	int tc[2];
};

static const struct mgl_encoding ec_base[] = {
{	MGL_KEY_ESC,		{'\e',		'\e'}	},
{	MGL_KEY_TAB,		{'\t',		'\t'}	},
{	MGL_KEY_Q,		{'q',		'Q'}	},
{	MGL_KEY_W,		{'w',		'W'}	},
{	MGL_KEY_E,		{'e',		'E'}	},
{	MGL_KEY_R,		{'r',		'R'}	},
{	MGL_KEY_T,		{'t',		'T'}	},
{	MGL_KEY_Y,		{'y',		'Y'}	},
{	MGL_KEY_U,		{'u',		'U'}	},
{	MGL_KEY_I,		{'i',		'I'}	},
{	MGL_KEY_O,		{'o',		'O'}	},
{	MGL_KEY_P,		{'p',		'P'}	},
{	MGL_KEY_ENTER,		{'\r',		'\r'}	},
{	MGL_KEY_CAPS,		{MGL_SKM_CAPS,	MGL_SKM_CAPS}},
{	MGL_KEY_A,		{'a',		'A'}},
{	MGL_KEY_S,		{'s',		'S'}},
{	MGL_KEY_D,		{'d',		'D'}},
{	MGL_KEY_F,		{'f',		'F'}},
{	MGL_KEY_G,		{'g',		'G'}},
{	MGL_KEY_H,		{'h',		'H'}},
{	MGL_KEY_J,		{'J',		'J'}},
{	MGL_KEY_K,		{'k',		'K'}},
{	MGL_KEY_L,		{'l',		'L'}},
{	MGL_KEY_SHIFT,		{MGL_SKM_SHIFT,	MGL_SKM_SHIFT}},
{	MGL_KEY_Z,		{'z',		'Z'}},
{	MGL_KEY_X,		{'x',		'X'}},
{	MGL_KEY_C,		{'c',		'C'}},
{	MGL_KEY_V,		{'v',		'V'}},
{	MGL_KEY_B,		{'b',		'B'}},
{	MGL_KEY_N,		{'n',		'N'}},
{	MGL_KEY_M,		{'m',		'M'}},
{	MGL_KEY_COMMA,		{',',		'<'}},
{	MGL_KEY_PERIOD,		{'.',		'>'}},
{	MGL_KEY_SLASH,		{'/',		'?'}},
{	MGL_KEY_RSHIFT,		{MGL_SKM_SHIFT,	MGL_SKM_SHIFT}},
{	MGL_KEY_CTRL,		{MGL_SKM_CTRL,	MGL_SKM_CTRL}},
{	MGL_KEY_ALT,		{MGL_SKM_ALT,	MGL_SKM_ALT}},
{	MGL_KEY_MENU,		{MGL_SKM_MENU,	MGL_SKM_MENU}},
{	MGL_KEY_SPACE,		{' ',		' '}},
{	MGL_KEY_F1,		{MK_F1,		MK_F1}	},
{	MGL_KEY_F2,		{MK_F2,		MK_F2}	},
{	MGL_KEY_F3,		{MK_F3,		MK_F3}	},
{	MGL_KEY_F4,		{MK_F4,		MK_F4}	},
{	MGL_KEY_F5,		{MK_F5,		MK_F5}	},
{	MGL_KEY_F6,		{MK_F6,		MK_F6}	},
{	MGL_KEY_F7,		{MK_F7,		MK_F7}	},
{	MGL_KEY_F8,		{MK_F8,		MK_F8}	},
{	MGL_KEY_F9,		{MK_F9,		MK_F9}	},
{	MGL_KEY_F10,		{MK_F10,	MK_F10}	},
{	MGL_KEY_UP,		{MK_UP,		MK_UP}	},
{	MGL_KEY_DOWN,		{MK_DOWN,	MK_DOWN}},
{	MGL_KEY_LEFT,		{MK_LEFT,	MK_LEFT}},
{	MGL_KEY_RIGHT,		{MK_RIGHT,	MK_RIGHT}},
{	MGL_KEY_INS,		{MK_INS,	MK_INS}},
{	MGL_KEY_DEL_ALT,	{0x7f,		0x7f}},
{	MGL_KEY_DEL,		{MK_DEL,	MK_DEL}},
{	MGL_KEY_PAGEUP,		{MK_PAGE_UP,	MK_PAGE_UP}},
{	MGL_KEY_PAGEDOWN,	{MK_PAGE_DOWN,	MK_PAGE_DOWN}},
{	MGL_KEY_HOME,		{MK_HOME,	MK_HOME}},
{	MGL_KEY_END,		{MK_END,	MK_END}},
};


const struct mgl_encoding ec_jp[] = {
{	MGL_KEY_HANZEN_J,	{'\e',		'\e'}	},
{	MGL_KEY_1,		{'1',		'!'}	},
{	MGL_KEY_2,		{'2',		'"'}	},
{	MGL_KEY_3,		{'3',		'#'}	},
{	MGL_KEY_4,		{'4',		'$'}	},
{	MGL_KEY_5,		{'5',		'%'}	},
{	MGL_KEY_6,		{'6',		'&'}	},
{	MGL_KEY_7,		{'7',		'\''}	},
{	MGL_KEY_8,		{'8',		'('}	},
{	MGL_KEY_9,		{'9',		')'}	},
{	MGL_KEY_0,		{'0',		'~'}	},
{	MGL_KEY_MINUS,		{'-',		'='}	},
{	MGL_KEY_ASCIICIRCUM_J,	{'^',		'~'}	},
{	MGL_KEY_BACKSLASH_BAR_J,{'\\',		'|'}	},
{	MGL_KEY_BACKSPACE,	{'\b',		'\b'}	},

{	MGL_KEY_AT_J,		{'@',		'`'}	},
{	MGL_KEY_LBRACKET_J,	{'[',		'{'}	},


{	MGL_KEY_SEMICOLON_J,	{';',		'+'}},
{	MGL_KEY_COLON_J,	{':',		'*'}},
{	MGL_KEY_RBRACKET_J,	{']',		'}'}},

{	MGL_KEY_BACKSLASH_UNDER,{'\\',		'_'}},


};

const struct mgl_encoding ec_us[] = {
{	MGL_KEY_1,		{'1',		'!'}	},
{	MGL_KEY_2,		{'2',		'@'}	},
{	MGL_KEY_3,		{'3',		'#'}	},
{	MGL_KEY_4,		{'4',		'$'}	},
{	MGL_KEY_5,		{'5',		'%'}	},
{	MGL_KEY_6,		{'6',		'^'}	},
{	MGL_KEY_7,		{'7',		'&'}	},
{	MGL_KEY_8,		{'8',		'*'}	},
{	MGL_KEY_9,		{'9',		'('}	},
{	MGL_KEY_0,		{'0',		')'}	},
{	MGL_KEY_MINUS,		{'-',		'_'}	},
{	MGL_KEY_EQUAL,		{'=',		'+'}	},
{	MGL_KEY_BACKSLASH_BAR_E,{'\\',		'|'}	},
{	MGL_KEY_GRAVE_E,	{'`',		'~'}	},

{	MGL_KEY_LBRACKET_E,	{'[',		'{'}	},
{	MGL_KEY_RBRACKET_E,	{']',		'}'}	},


{	MGL_KEY_SEMICOLON_E,	{';',		':'}},
{	MGL_KEY_APOSTROPHE_E,	{'\'',		'"'}},

/* for physical japanese keybard */
{	MGL_KEY_BACKSLASH_BAR_J,{'\\',		'|'}	},
{	MGL_KEY_BACKSLASH_UNDER,{'\\',		'_'}},
};


struct mgl_symval {
	char *sym;
	int val;
};

const struct mgl_symval sv_tab[] = {
{	"escape",	'\e'	},
{	"exclam",	'!'	},
{	"quotedbl",	'"'	},
{	"numbersign",	'#'	},
{	"dollar",	'$'	},
{	"percent",	'%'	},
{	"ampersand",	'&'	},
{	"apostrophe",	'\''	},
{	"parenleft",	'('	},
{	"parenright",	')'	},
{	"asciitilde",	'~'	},
{	"minus",	'-'	},
{	"equal",	'='	},
{	"asciicircum",	'^'	},
{	"asciitilde",	'~'	},
{	"backspace",	'\b'	},
{	"tab",		'\t'	},
{	"at",		'@'	},
{	"bracketleft",	'['	},
{	"bracketright",	']'	},
{	"braceright",	'{'	},
{	"braceleft",	'}'	},
{	"return",	'\r'	},
{	"semicolon",	';'	},
{	"colon",	':'	},
{	"comma",	','	},
{	"less",		'<'	},
{	"period",	'.'	},
{	"greater",	'>'	},
{	"slash",	'/'	},
{	"question",	'?'	},
{	"space",	' '	},
{	"bar",		'|'	},
{	"backslash",	'\\'	},
{	"underscore",	'_'	},
{	"capslock",	MGL_SKM_CAPS	},
{	"shift",	MGL_SKM_SHIFT	},
{	"alt",		MGL_SKM_ALT},
{	"ctrl",		MGL_SKM_CTRL	},
{	"menu",		MGL_SKM_MENU	},
{	"up",		MK_UP	},
{	"down",		MK_DOWN	},
{	"left",		MK_LEFT	},
{	"right",	MK_RIGHT },
{	"pageup",	MK_PAGE_UP },
{	"pagedown",	MK_PAGE_DOWN },
{	"insert",	MK_INS },
{	"delete",	0x7f },
{	"F1",		MK_F1	},
{	"F2",		MK_F2	},
{	"F3",		MK_F3	},
{	"F4",		MK_F4	},
{	"F5",		MK_F5	},
{	"F6",		MK_F6	},
{	"F7",		MK_F7	},
{	"F8",		MK_F8	},
{	"F9",		MK_F9	},
{	"F10",		MK_F10	},
{	"none",		-1 },
};

static char *find_val(int val) {
	int i;
	static char buf[2];
	for (i=0; i< sizeof(sv_tab)/sizeof(sv_tab[0]); i++) {
		if (sv_tab[i].val == val)
			return sv_tab[i].sym;
	}
	if ( (('a' <= val) && ('z' >= val ))
		    || (('A' <= val) && ('Z' >= val ))
		    || (('0' <= val) && ('9' >= val ))
		    || ('_' == val)  ) {
			buf[0] = val;
			buf[1] = 0;
			return buf;
	}
	return 0;
}

static int find_sym(char *name) {
	int i;
	for (i=0; i< sizeof(sv_tab)/sizeof(sv_tab[0]); i++) {
		if (!strcmp(sv_tab[i].sym,name)) 
			return sv_tab[i].val;
	}
	if (strlen(name) == 1) {
		if ( (('a' <= *name) && ('z' >= *name ))
		    || (('A' <= *name) && ('Z' >= *name ))
		    || (('0' <= *name) && ('9' >= *name ))
		    || ('_' == *name)  )
			return *name;
	}
		
	return -1;
}

static int local_translate;
static int mgl_keymap[128][2];

static void mk_init() {
	int i;
	for (i=0; i<128; i++) {
		mgl_keymap[ec_base[i].kc][0] = -1;
		mgl_keymap[ec_base[i].kc][1] = -1;
	}
	for (i=0; i< sizeof(ec_base)/sizeof(ec_base[0]);i++) {
		mgl_keymap[ec_base[i].kc][0] = ec_base[i].tc[0];
		mgl_keymap[ec_base[i].kc][1] = ec_base[i].tc[1];
	}
	mgl_key_ok 	= MGL_KEY_ENTER;
	mgl_key_cancel 	= MGL_KEY_ESC;
	mgl_key_up 	= MGL_KEY_UP;
	mgl_key_down 	= MGL_KEY_DOWN;
	mgl_key_left 	= MGL_KEY_LEFT;
	mgl_key_right 	= MGL_KEY_RIGHT;
	mgl_key_A 	= MGL_KEY_ALT;
	mgl_key_B 	= MGL_KEY_SPACE;
}

static int mk_set_type(char *sym) {
	int i;
	if (!strcmp("jp",sym)) {
	    for (i=0; i< sizeof(ec_jp)/sizeof(ec_jp[0]);i++) {
		mgl_keymap[ec_jp[i].kc][0] = ec_jp[i].tc[0];
		mgl_keymap[ec_jp[i].kc][1] = ec_jp[i].tc[1];
	    }
	    return 0;
	}
	if (!strcmp("us",sym)) {
	    for (i=0; i< sizeof(ec_us)/sizeof(ec_us[0]);i++) {
		mgl_keymap[ec_us[i].kc][0] = ec_us[i].tc[0];
		mgl_keymap[ec_us[i].kc][1] = ec_us[i].tc[1];
	    }
	    return 0;
	}
	return -1;
}

static int mk_swap_key(int key_a,int key_b) {
	int tmp;

	if ((key_a < 0) || (key_a >= 128)) return -1;
	if ((key_b < 0) || (key_b >= 128)) return -1;

	tmp = mgl_keymap[key_a][0];
	mgl_keymap[key_a][0] = mgl_keymap[key_b][0];
	mgl_keymap[key_b][0] = tmp;
	tmp = mgl_keymap[key_a][1];
	mgl_keymap[key_a][1] = mgl_keymap[key_b][1];
	mgl_keymap[key_b][1] = tmp;
	return 0;
}

static int mk_set_key(int key,char *sym1,char *sym2) {
	int v1=0,v2=0;

	if ((key < 0) || (key >= 128)) return -1;
	v1 = find_sym(sym1);
	if (sym2) v2 = find_sym(sym2);
	else v2 = v1;
	if ((v1 < 0) || (v2 < 0)) return -1;
	
	mgl_keymap[key][0] = v1;
	mgl_keymap[key][1] = v2;
	return 0;
}

static int mk_set_alias(char *sym,int key) {
	if (key < 0 || key >= 128) return -1;

	if (!strcmp("ok",sym)) mgl_key_ok = key;
	else if (!strcmp("cancel",sym)) mgl_key_cancel = key;
	else if (!strcmp("up",sym)) mgl_key_up = key;
	else if (!strcmp("down",sym)) mgl_key_down = key;
	else if (!strcmp("right",sym)) mgl_key_right = key;
	else if (!strcmp("left",sym)) mgl_key_left = key;
	else if (!strcmp("A",sym)) mgl_key_A = key;
	else if (!strcmp("B",sym)) mgl_key_B = key;
	else return -1;
	return 0;
}

static int load_keymap(FILE *fp) {
	char buf[256];
	char sym1[32];
	char sym2[32];
	char *p;
	int n,c,c2;
	int line=0;

	mk_init();
	while (fgets(buf,256,fp)) {
		line++;
		p = buf;
		while ((*p == ' ') || (*p == '\t')) p++;
		if ((*p == '#') || (*p == '\n') || (*p == 0)) continue;

		if (!strncmp("localtranslate",p,strlen("localtranslate"))) {
				local_translate = 1;
		} else if (sscanf(p,"swap %d %d",&c,&c2) == 2) {
			if (mk_swap_key(c,c2)) {
				fprintf(stderr,"keyswap error at %d\n",line);
				return -1;
			}
		}
		else if (sscanf(p,"keyboardtype = %30s",&sym1) == 1) {
			if (mk_set_type(sym1)) {
				fprintf(stderr,"keyboardtype error at %d\n",line);
				return -1;
			}
			
		}
		else if ((n = sscanf(p,"keycode %d = %30s %30s",&c,sym1,sym2))==2
			|| n == 3) {
			if (n == 2) strcpy(sym2,sym1);
			if (mk_set_key(c,sym1,sym2)) {
				fprintf(stderr,"keycode  error at %d\n",line);
				return -1;
			}
		}
		else if (sscanf(p,"alias %30s = %d",sym1,&c)==2) {
			if (mk_set_alias(sym1,c)) {
				fprintf(stderr,"alias error at %d\n",line);
				return -1;
			}
		} else {
				fprintf(stderr,"syntax error at %d\n",line);
				return -1;
		}
	}
	return 0;
}

static int init_keymap(char *opt, char *keymap_postfix) {
	char buf[5][64];
	int i,n = 0;
	int ok = 0;

	mk_init();
	if (opt) 
		n = sscanf(opt,"%60s %60s %60s %60s %60s"
			,buf[0],buf[1],buf[2],buf[3],buf[4]);
	if (n == 0) {
		mk_set_type("jp");
		ok = 1;
	} else {
		for (i=0; i<n; i++) {
			if (!strcmp("jp",buf[i])) {
				mk_set_type("jp");
				ok = 1;
			}
			if (!strcmp("us",buf[i])) {
				mk_set_type("us");
				ok = 1;
			}
			if (!strcmp("localtranslate",buf[i])) {
				local_translate = 1;
			}
			if (!strcmp("swapctrlcaps",buf[i])) {
				mk_swap_key(MGL_KEY_CTRL,MGL_KEY_CAPS);
			}
			if (!strcmp("swapdelbs",buf[i])) {
				mk_swap_key(MGL_KEY_DEL,MGL_KEY_BACKSPACE);
			}
			if (!strcmp("loadkeymap",buf[i])) {
				char fname[256];
				FILE *fp = NULL;
				int r = -1;

				if (keymap_postfix && keymap_postfix[0]) {
					strcpy(fname,MGLDIR);
					strcat(fname,"/keymap");
					strcat(fname,".");
					strcat(fname,keymap_postfix);
					if (fp = fopen(fname,"r")) {
						r = load_keymap(fp);
						fclose(fp);
					}
				}
				if (r) {
					strcpy(fname,MGLDIR);
					strcat(fname,"/keymap");
					if (fp = fopen(fname,"r")) {
						r = load_keymap(fp);
						fclose(fp);
					}
				}
				if (r) ok = 1;
			}
		}
	}
	return (ok)?0:-1;
}

#if 0
dump_keymap() {
	char sym1[32],sym2[32];
	char *p;
	int i;
	for (i=0; i<128; i++) {
		strcpy(sym1,"");
		strcpy(sym2,"");
		if (p = find_val(mgl_keymap[i][0])) {
			strcpy(sym1,p);
		}
		if (p = find_val(mgl_keymap[i][1])) {
			strcpy(sym2,p);
		}
		printf("keycode %3d = %30s %30s\n",i,sym1,sym2);
	}
}

main() {
	mgl_load_keymap(stdin);
	//dump_keymap();
}
#endif
